function printlic() {
  print "\nThis program is free software; you can redistribute it and/or modify"
  print "it under the terms of the GNU General Public License as published by"
  print "the Free Software Foundation; either version 2 of the License, or"
  print "(at your option) any later version."
  print ""
  print "This program is distributed in the hope that it will be useful,"
  print "but WITHOUT ANY WARRANTY; without even the implied warranty of"
  print "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the"
  print "GNU General Public License for more details.\n"}

#This routine inserted since many awks dont have toupper ;-(
function toupp() {
  ln=$0;
  gsub("a","A",ln); gsub("b","B",ln); gsub("c","C",ln); gsub("d","D",ln);
  gsub("e","E",ln); gsub("f","F",ln); gsub("g","G",ln); gsub("h","H",ln);
  gsub("i","I",ln); gsub("j","J",ln); gsub("k","K",ln); gsub("l","L",ln);
  gsub("m","M",ln); gsub("n","N",ln); gsub("o","O",ln); gsub("p","P",ln);
  gsub("q","Q",ln); gsub("r","R",ln); gsub("s","S",ln); gsub("t","T",ln);
  gsub("u","U",ln); gsub("v","V",ln); gsub("w","W",ln); gsub("x","X",ln);
  gsub("y","Y",ln); gsub("z","Z",ln)
}
# SSSQT: Written by Mark Katz, Mark-IT, www.mark-it.com, mark@mark-it.co.uk
# You may copy/use this code without restriction

function addtitle() {
#  This creates the title
  txt=$0; sub("<","", txt); sub(">", "=", txt); sub("<.*", "", txt)
  title= title txt ","}

function dotitle() {
  runt1=sprintf("struct;reclen=@@@\ned\nC Quantum code generated by SSSQT\nC %s\nC\nC Triple-S file (%s) created :", ver, FILENAME)
  runt2=sprintf("C   %s\n*include counts\n*include edit\nend\n", title)
  addtitle(); sub("title=", "", txt); jtitle=txt; sub("^  *","", jtitle)
  runt3="a;dsp;op=12;flush;spechar=-*;dec=0;pagwid=132;date;ttord=(side,top,high,tab)"
  runt4=sprintf("ttc %s\n*include %s\n*include %s\n", jtitle, tabs, axes)}

function domult() {
# print "in domult", "maxc=" maxc, axish, "stm1/2=" stm[1], stm[2]
  xt=length(sprintf("%d", maxc))
  print axish "\n*include base\nfld c" start ",c" finish+1-xt ":" xt  > axes
  for (i=1; i<=axc+0; i++) print "+" stm[i] > axes
  axc=maxc=0}

BEGIN {
# Set version number and file names
  ver="triple-s to Quantum converter - version 1.3b (spec), 4 July 2002"
  print "\n" ver "\n"
  ver= ver "\nC Developed by Mark-it, London.  mailto:mark@mark-it.co.uk"
  run="run"; edit="edit"; tabs="tabs"; axes="axes"; counts="counts"
  if (ARGC == 1) {
    print "**> ERROR No triple-s (XML) input-file given - usage 'sssqt filename'";
    printlic(); exit}
  print "C The Edit file" > edit
  going=1}

{
# The main body of the program
# Convert line to upper case - easier to check and subsitute quotes

  ln=toupper($0);
# Map all the HTML 'entity characters'
  gsub("&quot;*", "\"", $0); gsub("&#34;*", "\"", $0)
  gsub("&apos;*", "'", $0);  gsub("&#44;*", "'", $0)
  gsub("&amp;*", "\\&", $0); gsub("&#38;*", "\\&", $0)
  gsub("&lt;*", "<", $0);    gsub("&#60;*", ">", $0)
  gsub("&gt;*", ">", $0);    gsub("&#62;*", ">", $0)

  if (ln ~/<DATE>/ || ln ~ /<TIME>/ || ln ~/<ORIGIN>/) {addtitle(); next}

  if (ln ~/<TITLE>/) {dotitle(); next}

  if (ln ~ /<NAME>/) {
    name=ln; sub(".*<NAME>", "", name); sub("<.*","",name)
    uname=substr(name,1,7)
    if (uname in lnames) {
      uname=sprintf("tmpv%03d", ++un)
      print "--> Temp name ", uname " substituted for " name
      print "C Temp name ", uname " substituted for " name > edit}
    lnames[uname]=1; next}

  if (ln ~ /<VARIABLE /) {
    if (type ~ /MULT/) domult()
    type=ln; sub(".*YPE=.","", type); sub(".>.*","",type); next}
  if (ln ~ /<LABEL>/) {
    labl=$0; sub(".*<[Ll][Aa][Bb][Ee][Ll]>","", labl); sub("<.*","",labl);
    labl= name "_" labl;
    if (length(labl) > 200) {
      print "**>Label too long - truncated to 190 chars"
      labl=substr(labl,1,190)}
    axish = sprintf("\nL %s\nttl%s", uname, labl)
    printf "%-40s %-10s %s\n", labl, type, uname

    typa="col";
    if (type == "SINGLE")    {typa="val"; noaxes++}
    if (type == "QUANTITY")  {typa="val"; noinc++}
    if (type == "MULTIPLE")  {typa="fld"; noaxes++}
    if (type == "CHARACTER") {typa="cha"; noalph++}

    if (type != "QUANTITY" && type != "CHARACTER") {
      printf "tab %s bkdown\n", uname > tabs}
    elc=0; next}

  if (ln ~ /<POSITION /) {
    start=$2; sub(".*.=.", "", start); sub(".$","",start);
    start+=0; range=start; finish=start;

    if ($0 ~ /[Ff][Ii][Nn]/) {
      finish=$3; sub(".*=.", "", finish); sub(".$", "", finish)}
    finish+=0; if (maxl+0 < finish) maxl=finish
    if (start+0 != finish) range= "(" range "," finish ")"
  
  if (type !~ /MULT/) {
    suff=""; if (typa == "val") suff=";i;"
    axish=axish "\n*include base\n" typa " c" range suff}
  len=finish+1-start;
# next
  }

  if (ln ~ /<VALUE CODE/) {
    txt=value=$0;
#   if (gsub("=", "'equal'", txt)) print "++++" $0 , txt
    sub(".*\">", "", txt); sub("</.*", "", txt)
    gsub("=", "'equal'", txt)
    sub(".*=\"", "", value); sub("\".*", "", value);
    if (txt == "" || txt == " ") txt="Value of " value
    if (type !~ /MULT/) {
      if (elc++ == 0) print axish > axes
      printf "+%s=%d\n",txt, value > axes; next} else {
      stm[++axc]=txt "=" value; if (maxc < value+0) maxc=value+0
#     print "++" axc, txt, value
      }
    next}


  if (ln ~ /<RANGE /) {
    from=$2; sub(".*from=.", "", from); sub("\".*", "", from);
    to=$3; sub(".*to=.", "", to); sub("\".*", "", to);
    decp=index(to, ".");
    dps="int"; if (decp > 0) {reals[uname]=1; dps="real"} else ints[uname]=1
    print "C numeric '" uname "' set in cols", range, "- " dps > edit
    print "      " uname "=c" range > edit
# Not sure if to make them a variable too
#    if (elc++ == 0) print axish ";i;" > axes
#    printf "+%d-%d\n",from,to > axes
     next}
   }

END {
 if (going ==1) {
   if (maxc > 0) domult()
   sub("@@@", maxl, runt1)
   for (i in reals) print "real", i, "1" > run
   prefix="real"
   for (i in ints) print prefix, i, "1" > run
   printf "Written to files :-\n'Axes' in %s, 'Tabs' in %s, 'Run' in %s, 'Counts' in %s\n", axes, tabs, run,counts
   xrange="1"; if (maxl > 1) xrange= "1," maxl
   print "      Count c(" xrange ") $Hole Count for " jtitle "$" > counts
   print runt1 > run;  print runt2 > run; print runt3 > run;  print runt4 > run}
 printf "\nSSSQT Job Ends. %d axes, %d multipliers %d alphas\n", noaxes, noinc, noalph
 print "Limited support is provided by e-mail via support@mark-it.co.uk"
 }
